require 'delegate'

class TicketSeller
	def sellTicket()
		return 'Here is a ticket'
	end
	def try_delegate_to_super()
		puts "In TicketSeller.try_delegate_to_super"
	end
	def allowSales(allowit)
		puts "In TicketSeller allowSales"
	end
end

class NoTicketSeller
	def sellTicket()
		return "Sorry-come back tomorrow"
	end
end

class TicketOffice < SimpleDelegator
	def initialize
		@seller = TicketSeller.new
		@noseller = NoTicketSeller.new
		super(@seller)
	end
	def allowSales(allow = true)
		__setobj__(allow ? @seller : @noseller)
		allow
	end
end

class FooBar < TicketOffice
	def try_delegate_to_super()
		puts "In try_delegate_to_super"
		super
	end
end

to = FooBar.new
puts to.sellTicket
to.try_delegate_to_super
